case class Queue[A](in:List[A] = Nil, out:List[A] = Nil) {
    
    //QUESTION 1
    
    /** Ajoute un élément `x` en tête. */
    def enqueue(x:A):Queue[A] = this match {
        case Queue(Nil, h::t) => Queue(x::(h::t).reverse, Nil)
        case Queue(i, o) => Queue(x::i, o)
    }

    /** Retire le dernier élément. */
    //Peut ne pas fonctionner
    /**
    def dequeue():(A,Queue[A]) = this match {
        //cas bloquant
        case Queue(Nil, Nil) => sys.error("vilain effet de bord, faut corriger ça")
        
        case Queue(i, Nil) => {
            val rev = i.reverse
            (rev.head, Queue(Nil, rev.tail))
        }
        case Queue(Nil, o) => (o.head, Queue(Nil, o.tail))
    }
    **/

    //Fonctionnera
    def dequeue():(Option[A],Queue[A]) = this match {
        case Queue(Nil, Nil) => (None, Queue(Nil, Nil))
        case Queue(i, Nil) => {
            val rev = i.reverse
            (Some(rev.head), Queue(Nil, rev.tail))
        }
        case Queue(Nil, o) => (Some(o.head), Queue(Nil, o.tail))
    }

    /** Accès au premier élément, s'il existe. */
    def headOption():Option[A] = this match {
        case Queue(Nil, Nil) => None
        case Queue(Nil, o) => Some(o.head)
        case Queue(i, Nil) => Some(i.reverse.head)
    }

    /** Vrai si la liste est vide. */
    def isEmpty:Boolean = in.isEmpty && out.isEmpty

    
    //QUESTION 2

    def length():Int = this match {
        case Queue(Nil, Nil) => 0
        case Queue(l, Nil) => l.length
        case Queue(Nil, l) => l.length
    }


    //QUESTION 3

    def rearOption():Option[A] = this match {
        case Queue(Nil, Nil) => None
        case Queue(Nil, o) => Some(o.reverse.head)
        case Queue(i, Nil) => Some(i.head)
    }


    //QUESTION 4

    def toList():List[A] = this match {
        case Queue(Nil, Nil) => Nil
        case Queue(i, Nil) => i.reverse
        case Queue(Nil, o) => o
    }


    //QUESTION 5

    def map[B](f:A => B):Queue[B] = this match {
        case Queue(Nil, Nil) => Queue(Nil, Nil)
        case Queue(i, Nil) => Queue(i.map(f), Nil)
        case Queue(Nil, o) => Queue(Nil, o.map(f))
    }


    //QUESTION 6

    def foldLeft[B](z:B)(f:(B, A) => B):B = this match {
        case Queue(i, Nil) => i.reverse.foldLeft(z)(f)
        case Queue(Nil, o) => o.foldLeft(z)(f)
    }
}

object Main {
    import Queue._

    def main(args:Array[String]) {
        //Queue in itself test
        val q:Queue[Int] = Queue(Nil, Nil)
        println("Empty queue created, gonna enqueue in it now")
        val fullQ = q.enqueue(1).enqueue(2).enqueue(3).enqueue(4).enqueue(5)
        println("It is now not empty anymore. Now, we are going to dequeue it.")

        val dequeued = q.dequeue._2
        println("We can see that the 5 was sucessfully dequeued.")

        val q2 = dequeued.enqueue(5)
        println("We have renqueued the value we juste dequeued. Good, good.")

        println("We will now try to get the head :")
        val head = q2.headOption

        println("It worked. Good, good. Now, we test can dequeue the head and get the new one :")
        val dequeued2 = q2.dequeue._2
        val head2 = dequeued2.headOption

        println("It worked, wonderful. Don't need to test isEmpty, because it was written by great teacher.")

        println("We will now test the other methods. We will start with the length method :")
        val l = dequeued2.length
        println("We have the good length, great. Now to test the length once enqueued again:")
        val q3 = dequeued2.enqueue(5)

    }
}